@import "../../../styles/global/var";
@import "../../../styles/global/var-pages";
@import "../../../styles/ui/components/animation";

.test-run-card {
    .p-test-details & {
        padding: 5px 20px;
        position: fixed;
        left: 60px;
        top: 60px;
        right: 0;
        background-color: $white;
        z-index: 2;
        box-shadow: 0 4px 8px 0 rgba(4, 0, 0, 0.2);
    }
    &__clickable {
        position: absolute;
        top: 0;
        bottom: 0;
        right: 0;
        left: 0;
        z-index: 1;
        &:hover {
            background-color: rgba($black, .05);
        }
        &._highlighting {
            animation: change-color 3s ease-in-out 1;
        }
    }
    &__wrapper {
        &.background-gray .test-run-card__clickable:hover {
            background-color: transparent;
        }
        &.background-gray .test-run-card__copy {
            background-color: $gray-hover;
        }
        &.background-gray .test-run-card__copy::before {
            background: linear-gradient(90deg, rgba($white, 0) 0%, rgba($gray-hover, 1) 100%);
        }
        &-left,
        &-right {
            display: flex;
        }
        &-left {
            width: 40%;
            flex-grow: 1;
            min-width: 400px;
        }
        &-right {
            width: 60%;
            position: relative;
        }
        position: relative;
        background-color: $white;
        border-left: 4px solid #777;
        min-height: 55px;
        display: flex;
        &.PASSED {
            border-left-color: $green-new;
        }

        &.FAILED {
            border-left-color: $red-new;
        }

        &.IN_PROGRESS {
            border-left-color: $blue-new;
        }

        &.LAUNCHING {
            border-left-color: transparent;
        }
    }
    .expand-button {
        width: 20px !important;
        height: 20px !important;
        margin: 0 5px;
        left: 0;
        .fa-angle-double-down {
            background-color: $gray3e5;
            &, & img {
                width: 100%;
                height: 100%;
            }
            &:before {
                content: "";
            }
        }
    }

    &__cell {
        display: flex;
        align-items: center;
        color: $black;
        font-size: 13px;
        border-top: 1px $gray3e5 solid;
        flex-shrink: 0;
        padding: 5px;
        &._selection {
            justify-content: center;
            width: 53px;
            font-size: 14px;
            padding-right: 0;
            md-checkbox {
                margin-bottom: 0;
                width: 40px;
                height: 40px;

                .md-container {
                    left: 50%;
                    transform: translate3d(-50%, -50%, 0);
                    backface-visibility: hidden;
                }
            }
            span {
                z-index: 2;
            }
            .md-label {
                margin: 0;
            }
        }
        &._info {
            flex-grow: 1;
            flex-direction: column;
            align-items: flex-start;
            justify-content: center;
            flex-shrink: 1;
            min-width: 200px;
        }
        &._back {
            padding: 0;
        }
        &._env,
        &._platform {
            .label {
                color: $dark-coal-new;
                background-color: rgba(31, 36, 42, .1);
                display: inline-block;
                vertical-align: middle;
                font-size: 12px;
                font-weight: 500;
                text-transform: uppercase;
                padding: 0;
                height: 20px;
                border-radius: 10px;
                line-height: 20px;
            }
            .label,
            .platform-icon {
                margin: 0 8px 0 0;
            }
        }

        &._env {
            justify-content: center;
            flex-grow: 1;
            width: 11%;
            min-width: 100px;
            & .label {
                font-weight: bold;
                padding: 0 8px;
                margin: 0;
            }
        }
        &._platform {
            flex-grow: 2;
            width: 8%;
            min-width: 90px;
            justify-content: center;
            @media(min-width: $breakpoint-tablet-s + 1) and (max-width: 1120px){
                flex-grow: 0;
            }
            @media(min-width: $breakpoint-mobile) and (max-width: 630px){
                flex-grow: 1;
            }
            .label {
                background-color: transparent;
                overflow: hidden;
                text-overflow: ellipsis;
                white-space: nowrap;
                max-width: 45px;
                z-index: 2;
                cursor: default;
                @media(max-width: $breakpoint-tablet-s) {
                    max-width: 100%;
                }
            }
        }
        &._date {
            flex-grow: 2;
            flex-direction: column;
            align-items: flex-start;
            justify-content: center;
            width: 11%;
            min-width: 100px;
            font-weight: 500;
            font-size: 12px;
        }
        &._statistics {
            flex-grow: 1;
            width: 15%;
            min-width: 140px;
            @media (max-width: $breakpoint-mobile - 1) {
                justify-content: flex-start;
            }
            @media(min-width: $breakpoint-tablet-s + 1) and (max-width: 1120px){
                flex-grow: 1;
            }
            .label {
                font-size: 10px;
                display: inline-flex;
                min-width: 18px;
                min-width: fit-content;
                padding: 5px;
                min-width: 22px;
                justify-content: center;
                align-items: center;
                text-align: center;
                cursor: default;
                z-index: 2;
            }
            .label-success-border{
                border: 1px solid $green-new;
            }
            .label-success-empty {
                color: $green-new;
            }
            .label-success {
                background-color: $green-new;
            }
            .label-danger-border{
                border: 1px solid $red-new;
            }
            .label-danger-empty {
                color: $red-new;
            }
            .label-danger {
                background-color: $red-new;
            }
            .label-warning-border{
                border: 1px solid $yellow-new;
            }
            .label-warning-empty {
                color: $yellow-new;
            }
            .label-warning {
                background-color: $yellow-new;
            }
            .label-aborted-border{
                border: 1px solid $gray3e5;
            }
            .label-aborted-empty {
                color: $gray3e5;
            }
            .label-aborted-bg {
                background-color: $gray3e5;
            }
            .label + .label {
                margin-left: 2px;
            }
            .delimiter {
                margin: 0 2px;
            }
        }
        &._menu {
            z-index: 2;
            width: 6%;
            min-width: 40px;
            justify-content: center;
            .md-button {
                margin: 0;
            }
        }
    }

    &__row {
        display: flex;
        &._wrapper {
            display: block;
        }
        &._top {
            padding-bottom: 10px;
            .test-run-card__cell {
                justify-content: flex-start;
                align-items: flex-start;
            }
        }
        &._middle {
            border-top: 1px rgba($black, 0.12) solid;
        }
    }

    &__title {
        font-weight: bold;
        font-size: 16px;
        position: relative;
        line-height: 24px;
        margin-right: 10px;
        z-index: 2;
        max-width: 100%;
        overflow: hidden;
        text-overflow: ellipsis;
        &-text {
            white-space: nowrap;
            overflow: hidden;
        }
        &:hover .test-run-card__title-text {
            text-overflow: clip;
        }
        &:hover .test-run-card__copy {
            transform: translateX(0);
            transition: transform 0.25s ease-in-out .1s;
        }
        &-wrapper {
            display: flex;
            align-items: center;
            max-width: 100%;
        }
        &-additions {
            margin-left: 5px;
            z-index: 2;
            display: flex;
            justify-content: center;
            align-items: center;
            flex-grow: 0;
            flex-shrink: 0;
        }
    }

    &__copy {
        border: none;
        position: absolute;
        right: 0;
        top: 0;
        width: 24px;
        padding: 0;
        height: 24px;
        background-color: $white;
        transform: translateX(150%);
        transition: none;
        font-size: 0;
        &-icon.material-icons {
            font-size: 16px;
            line-height: 24px;
            &:hover {
                color: $black;
            }
        }
        &::before {
            content: '';
            cursor: default;
            position: absolute;
            top: 0;
            right: 100%;
            height: 100%;
            width: 50%;
            background: linear-gradient(90deg, rgba($white, 0) 0%, rgba($white, 1) 100%);
        }
        @media(max-width: $screen-md) {
            display: none;
        }
    }

    &__job {
        z-index: 2;
        display: flex;
        flex-wrap: wrap;
        font-weight: 500;
        align-items: center;
        max-width: 100%;
        &-name {
            font-size: 12px;
            line-height: 18px;
            margin-right: 15px;
            max-width: 100%;
            a {
                display: inline-block;
                max-width: 100%;
                white-space: nowrap;
                overflow: hidden;
                text-overflow: ellipsis;
                vertical-align: middle;
            }
        }
        &-file {
            display: flex;
            align-items: center;
            max-width: 100%;
            position: relative;
        }
    }
    &__locale {
        display: flex;
        align-items: center;
        margin-right: 15px;
        &-icon.material-icons {
            height: 12px;
            width: 12px;
            min-height: 12px;
            min-width: 12px;
            margin-right: 2px;
            font-size: 12px;
        }
        &-text {
            font-size: 12px;
            line-height: 18px;
            font-weight: 500;
            color: rgba($black, .5);
            white-space: nowrap;
            overflow: hidden;
            text-overflow: ellipsis;
        }
    }
    &__artifacts {
        z-index: 2;
        display: flex;
        flex-wrap: wrap;
    }
    &__artifact {
        display: flex;
        align-items: flex-end;
        color: $gray57c;
        font-size: 12px;
        margin: 0 16px 0 0;
        text-decoration: none;
        position: relative;
        &:hover {
            text-decoration: none;
            color: $black;
        }
        md-icon {
            min-height: 14px;
            height: 14px;
            font-size: 14px;
            min-width: 14px;
            width: 14px;
            color: currentColor;
            text-decoration: none;
        }
        span {
            font-size: 12px;
            margin: 0 0 0 3px;
            overflow: hidden;
            white-space: nowrap;
            text-decoration: underline;
        }
    }
    &__app {
        &-icon {
            flex-grow: 0;
            flex-shrink: 0;
            margin: 0;
            &._spinner {
                width: 10px;
                margin-left: 2px;
                opacity: 0;
                visibility: hidden;
                transition: visibility .25s ease-in-out, opacity .25s ease-in-out;
                &._show {
                    opacity: 1;
                    visibility: visible;
                }
            }
            &._file {
                height: 12px;
                width: 12px;
                min-height: 12px;
                min-width: 12px;
                margin-right: 2px;
                font-size: 12px;
            }
        }
        &-name {
            font-size: 12px;
            line-height: 18px;
            font-weight: 500;
            color: rgba($black, .5);
            white-space: nowrap;
            overflow: hidden;
            text-overflow: ellipsis;
        }
    }

    &__time {
        display: flex;
        align-items: center;
        &._light {
            color: rgba($coal, .25);
        }
        &-text,
        &-icon {
            vertical-align: middle;
        }
        &-icon.material-icons {
            color: currentColor;
            margin-right: 4px;
            font-size: 12px;
        }
        &-text {
            line-height: 14px;
        }
        & + & {
            margin-left: 10px;
        }
    }

    &__state {
        & + & {
            margin-left: 10px;
        }
        &._badge {
            height: 20px;
            width: 20px;

            .icon {
                min-height: 20px;
                min-width: 20px;
                width: 20px;
                height: 20px;
            }
        }
        &._comments {
            .comments-area {
                .icon {
                    min-height: 20px;
                    min-width: 20px;
                    width: 20px;
                    height: 20px;
                }
            }
        }
    }

    &__platform-wrapper {
        width: 80px;
        display: flex;
        align-items: center;
    }
    &__special-label {
        align-self: center;
        margin-right: 16px;
        margin-bottom: 8px;
        width: 16px;
        height: 16px;
        position: relative;
        background-image: url('./../../../assets/images/special-label-gray.svg');
        &:hover {
            background-image: url('./../../../assets/images/special-label-black.svg');
        }
        @media(max-width: $breakpoint-tablet-s) {
            display: none;
        }
    }

    @media(min-width: $breakpoint-mobile) and (max-width:  $breakpoint-tablet-s) {
        &__wrapper {
            &-left {
                position: relative;
                width: 100%;
                border-bottom: 1px rgba($black, 0.04) solid;
            }
            &-right {
                width: 100%;
            }
            flex-direction: column;
        }

        &__cell {
            &._env,
            &._platform,
            &._statistics,
            &._date,
            &._menu {
                border-top: none;
            }
            &._env {
                margin: 0 0 0 10px;
                justify-content: flex-start;
            }
            &._date {
                flex-grow: 2;
            }
            &._statistics {
                flex-grow: 2;
            }
        }
        &__title {
            &-wrapper {
                margin-right: 0;
                padding-right: 13px;
            }
        }
        &__job {
            padding-right: 13px;
        }
        &__app {
            &-name {
                max-width: 100%;
            }
        }
    }
    @media screen and (max-width: $breakpoint-tablet-m) {
        &__cell {
            &._info {
                min-width: 150px;
            }
        }
    }

    /*LAUNCHING TEST*/
    &._launch & {
        &__title, &__model {
            opacity: .5;
        }
        &__progressbar {
            opacity: .5;
            pointer-events: none;
            path {
                stroke: $dark-new;
            }
        }
    }
    &._launch._mobile & {
        &__row {
            &._top {
                padding-bottom: 0;
            }
        }
    }

    /*SINGLE TEST*/
    &._single {
        background-color: $white;
        z-index: 2;
        @media (min-width: $breakpoint-mobile) {
            padding: 2px 0;
        }
        .back {
            margin-top: 3px;
            cursor: pointer;
            @media (max-width: $breakpoint-mobile - 1) {
                margin-top: -3px;
            }
        }
        .test-run-card__special-label .info-popup {
            bottom: -5px;
            left: 100%;
            width: fit-content;
        }
    }

    &._single & {
        &__clickable {
            display: none;
        }
        &__wrapper {
            min-height: 45px;
            height: auto;
            @media (min-width: $breakpoint-mobile) {
                margin: 0 2px;
                padding: 0 15px;
            }
        }
        &__row {
            &._middle {
                border-top: none;
                background-color: $white;
                position: absolute;
                top: 0;
                left: -4px;
                right: 0;
                min-height: 100%;
                width: calc(100% + 4px);
                box-shadow: 0 4px 8px 0 rgba($black, .25);
                padding: 16px 12px;
                z-index: 2;
                & ._app-file {
                    padding: 0;
                }
            }
            &._app-file {
                padding-right: 30px;
            }
        }

        &__cell {
            border-top: 0;
            &._info {
                padding: 0;
            }
            &._selection {
                display: none;
            }
            &._env {
                @media(min-width: $breakpoint-mobile) and (max-width:  $breakpoint-tablet-s){
                    margin: 0;
                }
            }
        }

        &__title {
            .expand-button {
                width: 20px !important;
                height: 20px !important;
                margin: 5px;
                .expand-icon.fa-angle-double-up {
                    background-color: $gray3e5;
                    &, & img {
                        width: 100%;
                        height: 100%;
                    }
                    &:before {
                        content: ""
                    }
                }
            }
        }

    }

    /* MOBILE LAYOUT */
    &._mobile & {
        &__clickable {
            position: absolute;
            top: -15px;
            bottom: -1px;
            right: -12px;
            left: -12px;
            z-index: 1;
            &:hover {
                background-color: transparent;
            }
        }
        &__wrapper {
            padding: 15px 12px;
            margin-bottom: 4px;
            display: block;
            position: relative;
            & .clear {
                display: none;
            }
        }
        &._middle {
            border-top: none;
        }

        &__row {
            &._data,
            &._tags {
                & .test-run-card__cell {
                    padding: 12px 0 0 0 !important;
                }
            }
            &._app-file {
                padding: 5px 0 0;

                align-items: center;
                .expand-button {
                    display: none;
                }
            }
            &._top {
                position: relative;
            }
            &._additional {
                padding: 12px 0 0;
                align-items: center;
                .test-run-card__cell._menu {
                    display: none;
                    margin-right: 0;
                    margin-left: auto;
                }
            }
        }
        &__cell {
            border-top: 0;
            min-width: auto;
            padding: 0;
            & .clear {
                display: none;
            }
            &._selection {
                min-width: 18px;
                width: 18px;
                md-checkbox {
                    display: block;
                    width: 30px;
                    margin-top: -5px;
                    margin-left: -5px;
                    height: 30px;
                }
            }
            &._actions {
                z-index: 2;
                width: 20px;
                flex-direction: column;
                justify-content: space-between;
                align-items: center;
                .expand-button {
                    margin: 0 auto;
                    left: 0;
                    top: 0;
                }
            }
            &._statistics {
                width: auto;
                flex-grow: 0;
            }
            &._info {
                padding: 0 12px;
                min-width: 0;
            }
            &._menu {
                width: 20px;
            }
            &._env {
                flex-grow: 0;
                flex-shrink: 1;
                width: auto;
                .label {
                    max-width: 100%;
                    text-overflow: ellipsis;
                    overflow: hidden;
                    white-space: nowrap;
                }
            }
            &._platform {
                margin-right: 0;
                margin-left: 12px;
                flex: none;
                width: auto;
                .platform-icon {
                    margin: 0 4px 0 0;
                }
                .label {
                    margin: 0;
                }
            }
            &._date {
                flex-direction: row;
                margin-left: 12px;
                align-items: center;
                justify-content: flex-start;
                flex-wrap: wrap;
            }
        }
        &__time {
            margin-right: 12px;
            margin-left: 0;
            &-icon {
                color: rgba($black, .5);
            }
        }

        &__title {
            line-height: normal;
            margin: 0 5px 0 0;
        }
        &__jenkins {
            font-size: 14px;
            line-height: 1;
            margin-top: 9px;
            max-width: 100%;
            display: flex;
            overflow: hidden;
            text-overflow: ellipsis;
            a {
                display: inline-block;
                white-space: nowrap;
                overflow: hidden;
                text-overflow: ellipsis;
                max-width: 100%;
                line-height: 1.2;
                vertical-align: middle;
            }
            span {
                text-overflow: ellipsis;
                overflow: hidden;
                white-space: nowrap;
            }
        }
        &__menu-btn {
            margin: -6px 0 0;
        }
        &__app {
            &-name {
                max-width: 100%;
            }
        }
        &__artifact {
            margin-top: 2px;
        }
    }

    &._mobile._single & {
        &__wrapper {
            min-height: 100px;
            padding: 0;
            margin-bottom: 0;
            display: flex;
            justify-content: space-between;
            &.PASSED .test-run-card__row._middle {
                border-left-color: $green-new;
            }

            &.FAILED  .test-run-card__row._middle {
                border-left-color: $red-new;
            }

            &.IN_PROGRESS .test-run-card__row._middle {
                border-left-color: $blue-new;
            }
        }
        &__row {
            .expand-button {
                width: 20px !important;
                height: 20px !important;
                margin: 0 5px;
                .expand-icon.fa-angle-double-up {
                    background-color: $gray3e5;
                    &, & img {
                        width: 100%;
                        height: 100%;
                    }
                    &:before {
                        content: ""
                    }
                }
            }
            &._top {
                padding: 15px 15px 20px 10px;
                z-index: 3;
                background: $white;
                width: 100%;
                transform: translateZ(0);
                box-shadow: 0 4px 8px 0 rgba($black, 0.25);
                transition: box-shadow .25s ease-in-out;
            }
            &._middle {
                transition: transform .25s ease-in-out, opacity .25s ease-in-out;
                height: auto;
                top: 100%;
                opacity: 0;
                transform: translateY(-100%);
                border-left: 4px solid #777;
                padding: 10px 12px 20px;
                box-shadow: none;
                .md-icon {
                    margin: 0 auto;
                }
                &:before {
                    content: "";
                    height: 2px;
                    border: none;
                    background-color: $main_container_bg-new;
                    position: absolute;
                    top: 0;
                    left: 0;
                    right: 0;
                }
            }
            &._additional {
                background: $white;
                align-items: center;
                padding: 10px 0 0 0;
                z-index: 4;
                .comments-area {
                    color: rgba($black, .5);
                }
            }
        }
        &__cell {
            &._info {
                padding: 0;
            }
        }

        &__show-more {
            position: absolute;
            bottom: 0;
            left: 50%;
            transform: translate(-50%, 0);
            background: none;
            border: none;
            opacity: .5;
            height: 30px;
            z-index: 4;
        }

        &__back-btn {
            margin: -7px 5px 0 0;
            &._close-info {
                margin: 0 12px 0 0;
            }
            @media (min-width: $screen-phone + 1) {
                display: none;
            }
        }
        &__state {
            &._badge{
                height: 20px;
                width: 20px;
            }
        }

        &__info-btn {
            padding: 0;
            height: 20px;
            width: 20px;
            line-height: 20px;
            color: rgba($black, .5);
            background-color: $white;
            border: 0;
            margin-right: 12px;
            .material-icons {
                transform: rotate(180deg);
                color: currentColor;
                font-size: 20px;
            }
        }
    }
    &._mobile._single._details & {
        &__wrapper {
            & .clear {
                display: block;
                position: absolute;
                left: calc(100% - 33px);
                top: 10px;
                border-radius: 0;
                opacity: .6;
                & .material-icons {
                    font-size: 20px;
                }
            }
        }
        &__row {
            &._top {
                box-shadow: none;
            }
            &._middle {
                transform: translateY(0);
                opacity: 1;
                box-shadow: 0 4px 8px 0 rgba(black, .25);
            }
        }
        &__show-more {
            transform: translate(-50%, -20%) rotate(180deg);
        }
    }

    &__bottom-right-buttons {
        margin-right: 0;
        margin-left: auto;
        display: flex;
        align-items: center;
    }

    .comments-area {
        overflow: hidden;
    }
}
